Index: /trunk/src/sys/uvm/uvm_map.c
===================================================================
--- /trunk/src/sys/uvm/uvm_map.c	(revision 151)
+++ /trunk/src/sys/uvm/uvm_map.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: uvm_map.c,v 1.263.4.3.4.1 2009/08/23 06:38:07 matt Exp $	*/
+/*	uvm_map.c,v 1.263.4.3.4.3 2010/08/19 07:30:31 matt Exp	*/
 
 /*
@@ -72,5 +72,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: uvm_map.c,v 1.263.4.3.4.1 2009/08/23 06:38:07 matt Exp $");
+__KERNEL_RCSID(0, "uvm_map.c,v 1.263.4.3.4.3 2010/08/19 07:30:31 matt Exp");
 
 #include "opt_ddb.h"
@@ -305,5 +305,5 @@
 static void	uvm_map_reference_amap(struct vm_map_entry *, int);
 static int	uvm_map_space_avail(vaddr_t *, vsize_t, voff_t, vsize_t, int,
-		    struct vm_map_entry *);
+		    int, struct vm_map_entry *);
 static void	uvm_map_unreference_amap(struct vm_map_entry *, int);
 
@@ -1853,5 +1853,5 @@
 static int
 uvm_map_space_avail(vaddr_t *start, vsize_t length, voff_t uoffset,
-    vsize_t align, int topdown, struct vm_map_entry *entry)
+    vsize_t align, int flags, int topdown, struct vm_map_entry *entry)
 {
 	vaddr_t end;
@@ -1866,5 +1866,25 @@
 		PMAP_PREFER(uoffset, start, length, topdown);
 #endif
-	if (align != 0) {
+	if ((flags & UVM_FLAG_COLORMATCH) != 0) {
+		KASSERT(align < uvmexp.ncolors);
+		if (uvmexp.ncolors > 1) {
+			const u_int colormask = uvmexp.colormask;
+			const u_int colorsize = colormask + 1;
+			vaddr_t hint = atop(*start);
+			const u_int color = hint & colormask;
+			if (color != align) {
+				hint -= color;	/* adjust to color boundary */
+				KASSERT((hint & colormask) == 0);
+				if (topdown) {
+					if (align > color)
+						hint -= colorsize;
+				} else {
+					if (align < color)
+						hint += colorsize;
+				}
+				*start = ptoa(hint + align); /* adjust to color */
+			}
+		}
+	} else if (align != 0) {
 		if ((*start & (align - 1)) != 0) {
 			if (topdown)
@@ -1922,5 +1942,6 @@
 	UVMHIST_LOG(maphist, "(map=0x%x, hint=0x%x, len=%d, flags=0x%x)",
 	    map, hint, length, flags);
-	KASSERT((align & (align - 1)) == 0);
+	KASSERT((flags & UVM_FLAG_COLORMATCH) != 0 || (align & (align - 1)) == 0);
+	KASSERT((flags & UVM_FLAG_COLORMATCH) == 0 || align < uvmexp.ncolors);
 	KASSERT((flags & UVM_FLAG_FIXED) == 0 || align == 0);
 
@@ -2000,5 +2021,5 @@
 			 */
 			switch (uvm_map_space_avail(&hint, length,
-			    uoffset, align, topdown, entry)) {
+			    uoffset, align, flags, topdown, entry)) {
 			case 1:
 				goto found;
@@ -2031,5 +2052,5 @@
 	/* Check slot before any entry */
 	hint = topdown ? entry->next->start - length : entry->end;
-	switch (uvm_map_space_avail(&hint, length, uoffset, align,
+	switch (uvm_map_space_avail(&hint, length, uoffset, align, flags,
 	    topdown, entry)) {
 	case 1:
@@ -2100,5 +2121,5 @@
 		}
 		switch (uvm_map_space_avail(&hint, length, uoffset, align,
-		    topdown, tmp)) {
+		    flags, topdown, tmp)) {
 		case 1:
 			entry = tmp;
@@ -2122,5 +2143,5 @@
 	}
 	switch (uvm_map_space_avail(&hint, length, uoffset, align,
-	    topdown, prev)) {
+	    flags, topdown, prev)) {
 	case 1:
 		entry = prev;
@@ -2163,5 +2184,5 @@
 	}
 	switch (uvm_map_space_avail(&hint, length, uoffset, align,
-	    topdown, tmp)) {
+	    flags, topdown, tmp)) {
 	case 1:
 		entry = tmp;
@@ -2189,5 +2210,5 @@
 		/* See if it fits. */
 		switch (uvm_map_space_avail(&hint, length, uoffset, align,
-		    topdown, entry)) {
+		    flags, topdown, entry)) {
 		case 1:
 			goto found;
@@ -4139,4 +4160,7 @@
 	/* XXX cgd 960926: the sparc #ifdef should be a MD hook */
 	kill_user_windows(l);   /* before stack addresses go away */
+#endif
+#ifdef __HAVE_CPU_VMSPACE_EXEC
+	cpu_vmspace_exec(l, start, end);
 #endif
 
@@ -4637,5 +4661,5 @@
 
 	error = uvm_map_prepare(map, 0, PAGE_SIZE, NULL, UVM_UNKNOWN_OFFSET,
-	    0, mapflags, &args);
+	    VM_PAGE_TO_COLOR(pg), mapflags | UVM_FLAG_COLORMATCH, &args);
 	if (error) {
 		uvm_pagefree(pg);
Index: /trunk/src/sys/uvm/uvm_page.h
===================================================================
--- /trunk/src/sys/uvm/uvm_page.h	(revision 151)
+++ /trunk/src/sys/uvm/uvm_page.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: uvm_page.h,v 1.55.14.1 2010/01/23 19:54:04 matt Exp $	*/
+/*	uvm_page.h,v 1.55.14.2 2011/04/29 08:16:42 matt Exp	*/
 
 /*
@@ -256,4 +256,7 @@
  * physical memory config is stored in vm_physmem.
  */
+#define	VM_PHYSMEM_PTR(i)	(&vm_physmem[i])
+#define	VM_PHYSMEM_PTR_SWAP(i, j) \
+	do { vm_physmem[(i)] = vm_physmem[(j)]; } while (0)
 
 extern struct vm_physseg vm_physmem[VM_PHYSSEG_MAX];
@@ -305,4 +308,9 @@
 
 #define VM_PAGE_TO_PHYS(entry)	((entry)->phys_addr)
+#define VM_PAGE_TO_COLOR(entry)	(atop((entry)->phys_addr) & uvmexp.colormask)
+
+#ifdef __HAVE_VM_PAGE_MD
+#define VM_PAGE_TO_MD(pg)	(&(pg)->mdpage)
+#endif
 
 /*
Index: /trunk/src/sys/uvm/uvm_pager.c
===================================================================
--- /trunk/src/sys/uvm/uvm_pager.c	(revision 151)
+++ /trunk/src/sys/uvm/uvm_pager.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: uvm_pager.c,v 1.92 2008/04/17 05:39:41 simonb Exp $	*/
+/*	uvm_pager.c,v 1.92 2008/04/17 05:39:41 simonb Exp	*/
 
 /*
@@ -40,5 +40,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: uvm_pager.c,v 1.92 2008/04/17 05:39:41 simonb Exp $");
+__KERNEL_RCSID(0, "uvm_pager.c,v 1.92 2008/04/17 05:39:41 simonb Exp");
 
 #include "opt_uvmhist.h"
@@ -113,5 +113,6 @@
 	mutex_init(&pager_map_wanted_lock, MUTEX_DEFAULT, IPL_NONE);
 	pager_map_wanted = false;
-	emergva = uvm_km_alloc(kernel_map, round_page(MAXPHYS), 0,
+	emergva = uvm_km_alloc(kernel_map,
+	    round_page(MAXPHYS) + ptoa(uvmexp.ncolors), 0,
 	    UVM_KMF_VAONLY);
 #if defined(DEBUG)
@@ -151,8 +152,10 @@
 	struct vm_page *pp;
 	vm_prot_t prot;
-	const bool pdaemon = curlwp == uvm.pagedaemon_lwp;
+	const bool pdaemon = (curlwp == uvm.pagedaemon_lwp);
+	const u_int first_color = VM_PAGE_TO_COLOR(*pps);
 	UVMHIST_FUNC("uvm_pagermapin"); UVMHIST_CALLED(maphist);
 
-	UVMHIST_LOG(maphist,"(pps=0x%x, npages=%d)", pps, npages,0,0);
+	UVMHIST_LOG(maphist,"(pps=0x%x, npages=%d, first_color=%u)",
+		pps, npages, first_color, 0);
 
 	/*
@@ -166,9 +169,10 @@
 
 ReStart:
-	size = npages << PAGE_SHIFT;
+	size = ptoa(npages);
 	kva = 0;			/* let system choose VA */
 
-	if (uvm_map(pager_map, &kva, size, NULL, UVM_UNKNOWN_OFFSET, 0,
-	    UVM_FLAG_NOMERGE | (pdaemon ? UVM_FLAG_NOWAIT : 0)) != 0) {
+	if (uvm_map(pager_map, &kva, size, NULL, UVM_UNKNOWN_OFFSET,
+	    first_color, UVM_FLAG_COLORMATCH | UVM_FLAG_NOMERGE
+	    | (pdaemon ? UVM_FLAG_NOWAIT : 0)) != 0) {
 		if (pdaemon) {
 			mutex_enter(&pager_map_wanted_lock);
@@ -181,5 +185,5 @@
 			emerginuse = true;
 			mutex_exit(&pager_map_wanted_lock);
-			kva = emergva;
+			kva = emergva + ptoa(first_color);
 			/* The shift implicitly truncates to PAGE_SIZE */
 			KASSERT(npages <= (MAXPHYS >> PAGE_SHIFT));
@@ -200,7 +204,8 @@
 enter:
 	/* got it */
-	for (cva = kva ; size != 0 ; size -= PAGE_SIZE, cva += PAGE_SIZE) {
+	for (cva = kva; npages != 0; npages--, cva += PAGE_SIZE) {
 		pp = *pps++;
 		KASSERT(pp);
+		KASSERT(((VM_PAGE_TO_PHYS(pp) ^ cva) & uvmexp.colormask) == 0);
 		KASSERT(pp->flags & PG_BUSY);
 		pmap_kenter_pa(cva, VM_PAGE_TO_PHYS(pp), prot);
@@ -222,5 +227,5 @@
 uvm_pagermapout(vaddr_t kva, int npages)
 {
-	vsize_t size = npages << PAGE_SHIFT;
+	vsize_t size = ptoa(npages);
 	struct vm_map_entry *entries;
 	UVMHIST_FUNC("uvm_pagermapout"); UVMHIST_CALLED(maphist);
@@ -232,6 +237,7 @@
 	 */
 
-	pmap_kremove(kva, npages << PAGE_SHIFT);
-	if (kva == emergva) {
+	pmap_kremove(kva, size);
+
+	if ((kva & ~ptoa(uvmexp.colormask)) == emergva) {
 		mutex_enter(&pager_map_wanted_lock);
 		emerginuse = false;
Index: /trunk/src/sys/uvm/uvm_pager.h
===================================================================
--- /trunk/src/sys/uvm/uvm_pager.h	(revision 151)
+++ /trunk/src/sys/uvm/uvm_pager.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: uvm_pager.h,v 1.38 2008/08/22 10:48:22 hannken Exp $	*/
+/*	$NetBSD: uvm_pager.h,v 1.38.12.1 2011/05/20 08:11:34 matt Exp $	*/
 
 /*
@@ -165,4 +165,5 @@
 #define PGO_NOTIMESTAMP 0x1000	/* don't mark object accessed/modified */
 #define PGO_RECLAIM	0x2000	/* object is being reclaimed */
+#define PGO_GLOCKHELD	0x4000	/* genfs_node's lock is already held */
 
 /* page we are not interested in getting */
Index: /trunk/src/sys/uvm/uvm_pglist.c
===================================================================
--- /trunk/src/sys/uvm/uvm_pglist.c	(revision 151)
+++ /trunk/src/sys/uvm/uvm_pglist.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: uvm_pglist.c,v 1.42.16.5 2010/01/23 20:03:28 matt Exp $	*/
+/*	uvm_pglist.c,v 1.42.16.6 2010/06/01 19:04:02 matt Exp	*/
 
 /*-
@@ -36,5 +36,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: uvm_pglist.c,v 1.42.16.5 2010/01/23 20:03:28 matt Exp $");
+__KERNEL_RCSID(0, "uvm_pglist.c,v 1.42.16.6 2010/06/01 19:04:02 matt Exp");
 
 #include <sys/param.h>
@@ -171,4 +171,6 @@
 			try = roundup2(max(low, ps->avail_start), alignment);
 			limit = min(high, ps->avail_start + ps->start_hint);
+			if (limit >= ps->avail_end)
+				return 0;
 			skip = 0;
 			continue;
@@ -185,18 +187,26 @@
 			continue;
 		}
-#ifdef DEBUG
+
 		/*
 		 * Make sure this is a managed physical page.
 		 */
-
-		if (vm_physseg_find(try, &cidx) != ps - vm_physmem)
-			panic("pgalloc contig: botch1");
-		if (cidx != try - ps->start)
-			panic("pgalloc contig: botch2");
-		if (vm_physseg_find(try + num - 1, &cidx) != ps - vm_physmem)
-			panic("pgalloc contig: botch3");
-		if (cidx != try - ps->start + num - 1)
-			panic("pgalloc contig: botch4");
-#endif
+		KDASSERTMSG(vm_physseg_find(try, &cidx) == ps - vm_physmem,
+		    ("%s: %s(%#x, &cidx) (%d) != ps - vm_physmem (%zd)",
+		     __func__, "vm_physseg_find", try,
+		    vm_physseg_find(try, &cidx), ps - vm_physmem));
+
+		KDASSERTMSG(cidx == try - ps->start,
+		    ("%s: cidx (%#x) != try (%#x) - ps->start (%#"PRIxPADDR")",
+		     __func__, cidx, try, ps->start));
+
+		KDASSERTMSG(vm_physseg_find(try + num - 1, &cidx) == ps - vm_physmem,
+		    ("%s: %s(%#x + %#x - 1, &cidx) (%d) != ps - vm_physmem (%zd)",
+		     __func__, "vm_physseg_find", try, num,
+		    vm_physseg_find(try, &cidx), ps - vm_physmem));
+
+		KDASSERTMSG(cidx == try - ps->start + num - 1,
+		    ("%s: cidx (%#x) != try (%#x) - ps->start (%#"PRIxPADDR") + num (%#x) - 1",
+		     __func__, cidx, try, ps->start, num));
+
 		tryidx = try - ps->start;
 		end = tryidx + num;
@@ -354,7 +364,8 @@
     struct pglist *rlist)
 {
-	int todo, limit, try;
+	int todo, limit, try, color;
 	struct vm_page *pg;
-	bool second_pass;
+	bool second_pass, colorless;
+	const int colormask = uvmexp.colormask;
 #ifdef DEBUG
 	int cidx = 0;	/* XXX: GCC */
@@ -366,4 +377,18 @@
 
 	KASSERT(mutex_owned(&uvm_fpageqlock));
+
+	/*
+	 * If the pageq (rlist) is empty, then no pages have been allocated
+	 * and we can start with any color.  If it wasn't empty, then the
+	 * starting color is the last page's next color.
+	 */
+	colorless = TAILQ_EMPTY(rlist);
+	color = (ps->avail_start + ps->start_hint) & colormask;
+#ifdef DIAGNOSTIC
+	if (!colorless) {
+		pg = TAILQ_LAST(rlist, pglist);
+		KASSERT(color == ((VM_PAGE_TO_COLOR(pg) + 1) & colormask));
+	}
+#endif
 
 	low = atop(low);
@@ -376,21 +401,53 @@
 
 	for (;; try++, pg++) {
+		KDASSERTMSG(limit <= ps->avail_end,
+		    ("%s: limit (%#x) > ps->avail_end (%#"PRIxPADDR")",
+		     __func__, limit, ps->avail_end));
+
 		if (try >= limit) {
 			if (ps->start_hint == 0 || second_pass)
 				break;
 			second_pass = true;
-			try = max(low, ps->avail_start);
+			try = max(low, ps->avail_start) - 1;
 			limit = min(high, ps->avail_start + ps->start_hint);
+			if (limit >= ps->avail_end)
+				break;
 			pg = &ps->pgs[try - ps->start];
 			continue;
 		}
-#ifdef DEBUG
-		if (vm_physseg_find(try, &cidx) != ps - vm_physmem)
-			panic("pgalloc simple: botch1");
-		if (cidx != (try - ps->start))
-			panic("pgalloc simple: botch2");
-#endif
-		if (VM_PAGE_IS_FREE(pg) == 0)
+
+		KDASSERTMSG(vm_physseg_find(try, &cidx) == ps - vm_physmem,
+		    ("%s: %s(%#x, &cidx) (%d) != ps - vm_physmem (%zd)",
+		     __func__, "vm_physseg_find", try,
+		    vm_physseg_find(try, &cidx), ps - vm_physmem));
+
+		KDASSERTMSG(cidx == try - ps->start,
+		    ("%s: cidx (%#x) != try (%#x) - ps->start (%#"PRIxPADDR")",
+		     __func__, cidx, try, ps->start));
+
+		/*
+		 * If this page isn't free, then we need to skip a colors worth
+		 * of pages to get a matching color.  Note that colormask is 1
+		 * less than what we need since the loop will also increment
+		 * try and pgs.
+		 */
+		if (VM_PAGE_IS_FREE(pg) == 0) {
+			try += colormask;
+			pg += colormask;
 			continue;
+		}
+
+		/*
+		 * If this page doesn't have the right color, figure out how
+		 * many pages we need to skip until we get to the right color.
+		 * Note that skip is 1 less that what we need since the loop
+		 * will also increment try and pgs.
+		 */
+		if (!colorless && (try & colormask) != color) {
+			const int skip = (color - (try + 1)) & colormask;
+			try += skip;
+			pg += skip;
+			continue;
+		}
 
 		uvm_pglist_add(pg, rlist);
@@ -398,4 +455,11 @@
 			break;
 		}
+
+		/*
+		 * Advance the color (use try instead of color in case we
+		 * haven't set an initial color).
+		 */
+		color = (try + 1) & colormask;
+		colorless = false;
 	}
 
Index: /trunk/src/sys/uvm/uvm_unix.c
===================================================================
--- /trunk/src/sys/uvm/uvm_unix.c	(revision 151)
+++ /trunk/src/sys/uvm/uvm_unix.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: uvm_unix.c,v 1.40.28.1 2009/08/23 06:38:07 matt Exp $	*/
+/*	$NetBSD: uvm_unix.c,v 1.40.28.2 2011/04/29 08:15:09 matt Exp $	*/
 
 /*
@@ -51,5 +51,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: uvm_unix.c,v 1.40.28.1 2009/08/23 06:38:07 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: uvm_unix.c,v 1.40.28.2 2011/04/29 08:15:09 matt Exp $");
 
 #include "opt_pax.h"
@@ -119,5 +119,5 @@
 		if (error) {
 #ifndef PRIdVSIZE
-#define	PRIdVSIZE	"%ld"
+#define	PRIdVSIZE	"ld"
 #endif
 			uprintf("sbrk: grow %"PRIdVSIZE" failed, error = %d\n",
Index: /trunk/src/sys/uvm/uvm_vnode.c
===================================================================
--- /trunk/src/sys/uvm/uvm_vnode.c	(revision 151)
+++ /trunk/src/sys/uvm/uvm_vnode.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: uvm_vnode.c,v 1.90 2008/01/02 11:49:21 ad Exp $	*/
+/*	uvm_vnode.c,v 1.90 2008/01/02 11:49:21 ad Exp	*/
 
 /*
@@ -51,5 +51,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: uvm_vnode.c,v 1.90 2008/01/02 11:49:21 ad Exp $");
+__KERNEL_RCSID(0, "uvm_vnode.c,v 1.90 2008/01/02 11:49:21 ad Exp");
 
 #include "fs_nfs.h"
@@ -258,5 +258,6 @@
 				return 0;
 			}
-			pg = uvm_pagealloc(uobj, offset, NULL, 0);
+			pg = uvm_pagealloc(uobj, offset, NULL,
+			    UVM_FLAG_COLORMATCH);
 			if (pg == NULL) {
 				if (flags & UFP_NOWAIT) {
Index: /trunk/src/tools/Makefile
===================================================================
--- /trunk/src/tools/Makefile	(revision 151)
+++ /trunk/src/tools/Makefile	(revision 152)
@@ -1,3 +1,3 @@
-#	$NetBSD: Makefile,v 1.124 2008/10/25 22:12:41 apb Exp $
+#	Makefile,v 1.124 2008/10/25 22:12:41 apb Exp
 
 .include <bsd.own.mk>
@@ -103,4 +103,9 @@
 .endif
 
+.if ${MACHINE} == "evbarm" || ${MACHINE} == "evbmips" || \
+    ${MACHINE} == "evbppc" || ${MACHINE} == "sandpoint"
+SUBDIR+=	mkubootimage
+.endif
+
 check_MKTOOLS: .PHONY .NOTMAIN
 .if ${MKTOOLS:Uyes} == "no"
Index: /trunk/src/tools/mkubootimage/Makefile
===================================================================
--- /trunk/src/tools/mkubootimage/Makefile	(revision 152)
+++ /trunk/src/tools/mkubootimage/Makefile	(revision 152)
@@ -0,0 +1,8 @@
+#	$NetBSD: Makefile,v 1.1.4.2 2011/05/20 15:05:11 matt Exp $
+
+HOSTPROGNAME=	${_TOOL_PREFIX}mkubootimage
+HOST_SRCDIR=	usr.bin/mkubootimage
+
+HOST_CPPFLAGS+= -I${.CURDIR}
+
+.include "${.CURDIR}/../Makefile.host"
Index: /trunk/src/usr.bin/Makefile
===================================================================
--- /trunk/src/usr.bin/Makefile	(revision 151)
+++ /trunk/src/usr.bin/Makefile	(revision 152)
@@ -1,3 +1,3 @@
-#	$NetBSD: Makefile,v 1.171 2008/10/29 16:49:33 christos Exp $
+#	Makefile,v 1.171 2008/10/29 16:49:33 christos Exp
 #	from: @(#)Makefile	8.3 (Berkeley) 1/7/94
 
@@ -16,6 +16,6 @@
 	kdump ktrace ktruss lam last lastcomm ldd leave less \
 	lex locale locate lock logger login logname look lorder m4 \
-	machine mail make man menuc mesg midiplay mixerctl mkcsmapper \
-	mkdep mkesdb mkfifo mklocale mkstr mktemp moduli msgc msgs \
+	machine mail make man menuc mesg midiplay mixerctl mkcsmapper mkdep \
+	mkesdb mkfifo mklocale mkstr mktemp mkubootimage moduli msgc msgs \
 	netgroup netstat newgrp newsyslog nfsstat nice nl nohup nvi \
 	pagesize passwd paste patch pathchk pkill pmap pmc pr \
Index: /trunk/src/usr.bin/mkubootimage/Makefile
===================================================================
--- /trunk/src/usr.bin/mkubootimage/Makefile	(revision 152)
+++ /trunk/src/usr.bin/mkubootimage/Makefile	(revision 152)
@@ -0,0 +1,7 @@
+# $NetBSD: Makefile,v 1.1.4.2 2011/05/20 15:05:11 matt Exp $
+
+PROG=	mkubootimage
+SRCS=	mkubootimage.c crc32.c
+NOMAN=	# defined
+
+.include <bsd.prog.mk>
Index: /trunk/src/usr.bin/mkubootimage/crc32.c
===================================================================
--- /trunk/src/usr.bin/mkubootimage/crc32.c	(revision 152)
+++ /trunk/src/usr.bin/mkubootimage/crc32.c	(revision 152)
@@ -0,0 +1,102 @@
+/* $NetBSD: crc32.c,v 1.2.4.2 2011/05/20 15:05:11 matt Exp $ */
+
+/*-
+ * Copyright (c) 2002 Marcel Moolenaar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ *
+ * CRC32 code derived from work by Gary S. Brown.
+ */
+
+#if HAVE_NBTOOL_CONFIG_H
+#include "nbtool_config.h"
+#endif
+
+#include <sys/cdefs.h>
+__RCSID("$NetBSD: crc32.c,v 1.2.4.2 2011/05/20 15:05:11 matt Exp $");
+
+#include <sys/types.h>
+#include <stdint.h>
+
+uint32_t	crc32(const void *, size_t);
+
+static uint32_t crc32_tab[] = {
+	0x00000000, 0x77073096, 0xee0e612c, 0x990951ba, 0x076dc419, 0x706af48f,
+	0xe963a535, 0x9e6495a3,	0x0edb8832, 0x79dcb8a4, 0xe0d5e91e, 0x97d2d988,
+	0x09b64c2b, 0x7eb17cbd, 0xe7b82d07, 0x90bf1d91, 0x1db71064, 0x6ab020f2,
+	0xf3b97148, 0x84be41de,	0x1adad47d, 0x6ddde4eb, 0xf4d4b551, 0x83d385c7,
+	0x136c9856, 0x646ba8c0, 0xfd62f97a, 0x8a65c9ec,	0x14015c4f, 0x63066cd9,
+	0xfa0f3d63, 0x8d080df5,	0x3b6e20c8, 0x4c69105e, 0xd56041e4, 0xa2677172,
+	0x3c03e4d1, 0x4b04d447, 0xd20d85fd, 0xa50ab56b,	0x35b5a8fa, 0x42b2986c,
+	0xdbbbc9d6, 0xacbcf940,	0x32d86ce3, 0x45df5c75, 0xdcd60dcf, 0xabd13d59,
+	0x26d930ac, 0x51de003a, 0xc8d75180, 0xbfd06116, 0x21b4f4b5, 0x56b3c423,
+	0xcfba9599, 0xb8bda50f, 0x2802b89e, 0x5f058808, 0xc60cd9b2, 0xb10be924,
+	0x2f6f7c87, 0x58684c11, 0xc1611dab, 0xb6662d3d,	0x76dc4190, 0x01db7106,
+	0x98d220bc, 0xefd5102a, 0x71b18589, 0x06b6b51f, 0x9fbfe4a5, 0xe8b8d433,
+	0x7807c9a2, 0x0f00f934, 0x9609a88e, 0xe10e9818, 0x7f6a0dbb, 0x086d3d2d,
+	0x91646c97, 0xe6635c01, 0x6b6b51f4, 0x1c6c6162, 0x856530d8, 0xf262004e,
+	0x6c0695ed, 0x1b01a57b, 0x8208f4c1, 0xf50fc457, 0x65b0d9c6, 0x12b7e950,
+	0x8bbeb8ea, 0xfcb9887c, 0x62dd1ddf, 0x15da2d49, 0x8cd37cf3, 0xfbd44c65,
+	0x4db26158, 0x3ab551ce, 0xa3bc0074, 0xd4bb30e2, 0x4adfa541, 0x3dd895d7,
+	0xa4d1c46d, 0xd3d6f4fb, 0x4369e96a, 0x346ed9fc, 0xad678846, 0xda60b8d0,
+	0x44042d73, 0x33031de5, 0xaa0a4c5f, 0xdd0d7cc9, 0x5005713c, 0x270241aa,
+	0xbe0b1010, 0xc90c2086, 0x5768b525, 0x206f85b3, 0xb966d409, 0xce61e49f,
+	0x5edef90e, 0x29d9c998, 0xb0d09822, 0xc7d7a8b4, 0x59b33d17, 0x2eb40d81,
+	0xb7bd5c3b, 0xc0ba6cad, 0xedb88320, 0x9abfb3b6, 0x03b6e20c, 0x74b1d29a,
+	0xead54739, 0x9dd277af, 0x04db2615, 0x73dc1683, 0xe3630b12, 0x94643b84,
+	0x0d6d6a3e, 0x7a6a5aa8, 0xe40ecf0b, 0x9309ff9d, 0x0a00ae27, 0x7d079eb1,
+	0xf00f9344, 0x8708a3d2, 0x1e01f268, 0x6906c2fe, 0xf762575d, 0x806567cb,
+	0x196c3671, 0x6e6b06e7, 0xfed41b76, 0x89d32be0, 0x10da7a5a, 0x67dd4acc,
+	0xf9b9df6f, 0x8ebeeff9, 0x17b7be43, 0x60b08ed5, 0xd6d6a3e8, 0xa1d1937e,
+	0x38d8c2c4, 0x4fdff252, 0xd1bb67f1, 0xa6bc5767, 0x3fb506dd, 0x48b2364b,
+	0xd80d2bda, 0xaf0a1b4c, 0x36034af6, 0x41047a60, 0xdf60efc3, 0xa867df55,
+	0x316e8eef, 0x4669be79, 0xcb61b38c, 0xbc66831a, 0x256fd2a0, 0x5268e236,
+	0xcc0c7795, 0xbb0b4703, 0x220216b9, 0x5505262f, 0xc5ba3bbe, 0xb2bd0b28,
+	0x2bb45a92, 0x5cb36a04, 0xc2d7ffa7, 0xb5d0cf31, 0x2cd99e8b, 0x5bdeae1d,
+	0x9b64c2b0, 0xec63f226, 0x756aa39c, 0x026d930a, 0x9c0906a9, 0xeb0e363f,
+	0x72076785, 0x05005713, 0x95bf4a82, 0xe2b87a14, 0x7bb12bae, 0x0cb61b38,
+	0x92d28e9b, 0xe5d5be0d, 0x7cdcefb7, 0x0bdbdf21, 0x86d3d2d4, 0xf1d4e242,
+	0x68ddb3f8, 0x1fda836e, 0x81be16cd, 0xf6b9265b, 0x6fb077e1, 0x18b74777,
+	0x88085ae6, 0xff0f6a70, 0x66063bca, 0x11010b5c, 0x8f659eff, 0xf862ae69,
+	0x616bffd3, 0x166ccf45, 0xa00ae278, 0xd70dd2ee, 0x4e048354, 0x3903b3c2,
+	0xa7672661, 0xd06016f7, 0x4969474d, 0x3e6e77db, 0xaed16a4a, 0xd9d65adc,
+	0x40df0b66, 0x37d83bf0, 0xa9bcae53, 0xdebb9ec5, 0x47b2cf7f, 0x30b5ffe9,
+	0xbdbdf21c, 0xcabac28a, 0x53b39330, 0x24b4a3a6, 0xbad03605, 0xcdd70693,
+	0x54de5729, 0x23d967bf, 0xb3667a2e, 0xc4614ab8, 0x5d681b02, 0x2a6f2b94,
+	0xb40bbe37, 0xc30c8ea1, 0x5a05df1b, 0x2d02ef8d
+};
+
+uint32_t
+crc32(const void *buf, size_t size)
+{
+	const uint8_t *p;
+	uint32_t crc;
+
+	p = buf;
+	crc = ~0U;
+
+	while (size--)
+		crc = crc32_tab[(crc ^ *p++) & 0xFF] ^ (crc >> 8);
+
+	return crc ^ ~0U;
+}
Index: /trunk/src/usr.bin/mkubootimage/mkubootimage.c
===================================================================
--- /trunk/src/usr.bin/mkubootimage/mkubootimage.c	(revision 152)
+++ /trunk/src/usr.bin/mkubootimage/mkubootimage.c	(revision 152)
@@ -0,0 +1,345 @@
+/* $NetBSD: mkubootimage.c,v 1.6.2.2 2011/05/20 15:05:11 matt Exp $ */
+
+/*-
+ * Copyright (c) 2010 Jared D. McNeill <jmcneill@invisible.ca>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. The name of the author may not be used to endorse or promote products
+ *    derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
+ * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+ * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
+ * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+ * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#if HAVE_NBTOOL_CONFIG_H
+#include "nbtool_config.h"
+#endif
+
+#include <sys/cdefs.h>
+__RCSID("$NetBSD: mkubootimage.c,v 1.6.2.2 2011/05/20 15:05:11 matt Exp $");
+
+#include <sys/mman.h>
+#include <sys/stat.h>
+#include <err.h>
+#include <errno.h>
+#include <fcntl.h>
+#include <limits.h>
+#include <stdint.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <time.h>
+#include <unistd.h>
+
+#include "uboot.h"
+
+#ifndef __arraycount
+#define __arraycount(__x)	(sizeof(__x) / sizeof(__x[0]))
+#endif
+
+extern uint32_t crc32(const void *, size_t);
+
+static enum uboot_image_os image_os = IH_OS_NETBSD;
+static enum uboot_image_arch image_arch = IH_ARCH_UNKNOWN;
+static enum uboot_image_type image_type = IH_TYPE_UNKNOWN;
+static enum uboot_image_comp image_comp = IH_COMP_NONE;
+static uint32_t image_loadaddr = 0;
+static uint32_t image_entrypoint = 0;
+static char *image_name;
+
+struct uboot_os {
+	enum uboot_image_os os;
+	const char *name;
+} uboot_os[] = {
+	{ IH_OS_OPENBSD,	"openbsd" },
+	{ IH_OS_NETBSD,		"netbsd" },
+	{ IH_OS_FREEBSD,	"freebsd" },
+	{ IH_OS_LINUX,		"linux" },
+};
+
+static enum uboot_image_os
+get_os(const char *name)
+{
+	unsigned int i;
+
+	for (i = 0; i < __arraycount(uboot_os); i++) {
+		if (strcmp(uboot_os[i].name, name) == 0)
+			return uboot_os[i].os;
+	}
+
+	return IH_OS_UNKNOWN;
+}
+
+struct uboot_arch {
+	enum uboot_image_arch arch;
+	const char *name;
+} uboot_arch[] = {
+	{ IH_ARCH_ARM,		"arm" },
+	{ IH_ARCH_MIPS,		"mips" },
+	{ IH_ARCH_MIPS64,	"mips64" },
+	{ IH_ARCH_PPC,		"powerpc" },
+};
+
+static enum uboot_image_arch
+get_arch(const char *name)
+{
+	unsigned int i;
+
+	for (i = 0; i < __arraycount(uboot_arch); i++) {
+		if (strcmp(uboot_arch[i].name, name) == 0)
+			return uboot_arch[i].arch;
+	}
+
+	return IH_ARCH_UNKNOWN;
+}
+
+struct uboot_type {
+	enum uboot_image_type type;
+	const char *name;
+} uboot_type[] = {
+	{ IH_TYPE_STANDALONE,	"standalone" },
+	{ IH_TYPE_KERNEL,	"kernel" },
+	{ IH_TYPE_RAMDISK,	"ramdisk" },
+	{ IH_TYPE_FILESYSTEM,	"fs" },
+};
+
+static enum uboot_image_type
+get_type(const char *name)
+{
+	unsigned int i;
+
+	for (i = 0; i < __arraycount(uboot_type); i++) {
+		if (strcmp(uboot_type[i].name, name) == 0)
+			return uboot_type[i].type;
+	}
+
+	return IH_TYPE_UNKNOWN;
+}
+
+struct uboot_comp {
+	enum uboot_image_comp comp;
+	const char *name;
+} uboot_comp[] = {
+	{ IH_COMP_NONE,		"none" },
+	{ IH_COMP_GZIP,		"gz" },
+	{ IH_COMP_BZIP2,	"bz2" },
+};
+
+static enum uboot_image_comp
+get_comp(const char *name)
+{
+	unsigned int i;
+
+	for (i = 0; i < __arraycount(uboot_comp); i++) {
+		if (strcmp(uboot_comp[i].name, name) == 0)
+			return uboot_comp[i].comp;
+	}
+
+	return IH_TYPE_UNKNOWN;
+}
+
+static void
+usage(void)
+{
+	fprintf(stderr, "usage: mkubootimage -A <arm|mips|mips64|powerpc>");
+	fprintf(stderr, " -C <none|gz|bz2>");
+	fprintf(stderr, " -O <openbsd|netbsd|freebsd|linux>");
+	fprintf(stderr, " -T <standalone|kernel|ramdisk|fs>");
+	fprintf(stderr, " -a <addr> [-e <ep>] -n <name>");
+	fprintf(stderr, " <srcfile> <dstfile>\n");
+
+	exit(EXIT_FAILURE);
+}
+
+static void
+dump_header(struct uboot_image_header *hdr)
+{
+	time_t tm = ntohl(hdr->ih_time);
+
+	printf(" magic:       0x%08x\n", ntohl(hdr->ih_magic));
+	printf(" time:        %s", ctime(&tm));
+	printf(" size:        %u\n", ntohl(hdr->ih_size));
+	printf(" load addr:   0x%08x\n", ntohl(hdr->ih_load));
+	printf(" entry point: 0x%08x\n", ntohl(hdr->ih_ep));
+	printf(" data crc:    0x%08x\n", ntohl(hdr->ih_dcrc));
+	printf(" os:          %d\n", hdr->ih_os);
+	printf(" arch:        %d\n", hdr->ih_arch);
+	printf(" type:        %d\n", hdr->ih_type);
+	printf(" comp:        %d\n", hdr->ih_comp);
+	printf(" name:        %s\n", hdr->ih_name);
+	printf(" header crc:  0x%08x\n", hdr->ih_hcrc);
+}
+
+static int
+generate_header(struct uboot_image_header *hdr, int kernel_fd)
+{
+	uint8_t *p;
+	struct stat st;
+	uint32_t crc;
+	int error;
+
+	error = fstat(kernel_fd, &st);
+	if (error == -1) {
+		perror("stat");
+		return errno;
+	}
+
+	if (st.st_size + sizeof(*hdr) > UINT32_MAX) {
+		fprintf(stderr, "fatal: kernel too big\n");
+		return EINVAL;
+	}
+
+	p = mmap(0, st.st_size, PROT_READ, MAP_FILE|MAP_SHARED, kernel_fd, 0);
+	if (p == MAP_FAILED) {
+		perror("mmap kernel");
+		return EINVAL;
+	}
+	crc = crc32(p, st.st_size);
+	munmap(p, st.st_size);
+
+	memset(hdr, 0, sizeof(*hdr));
+	hdr->ih_magic = htonl(IH_MAGIC);
+	hdr->ih_time = htonl(st.st_mtime);
+	hdr->ih_size = htonl(st.st_size);
+	hdr->ih_load = htonl(image_loadaddr);
+	hdr->ih_ep = htonl(image_entrypoint);
+	hdr->ih_dcrc = htonl(crc);
+	hdr->ih_os = image_os;
+	hdr->ih_arch = image_arch;
+	hdr->ih_type = image_type;
+	hdr->ih_comp = image_comp;
+	strncpy((char *)hdr->ih_name, image_name, sizeof(hdr->ih_name));
+	crc = crc32((void *)hdr, sizeof(*hdr));
+	hdr->ih_hcrc = htonl(crc);
+
+	dump_header(hdr);
+
+	return 0;
+}
+
+static int
+write_image(struct uboot_image_header *hdr, int kernel_fd, int image_fd)
+{
+	uint8_t buf[4096];
+	ssize_t rlen, wlen;
+
+	wlen = write(image_fd, hdr, sizeof(*hdr));
+	if (wlen != sizeof(*hdr)) {
+		perror("short write");
+		return errno;
+	}
+
+	while ((rlen = read(kernel_fd, buf, sizeof(buf))) > 0) {
+		wlen = write(image_fd, buf, rlen);
+		if (wlen != rlen) {
+			perror("short write");
+			return errno;
+		}
+	}
+
+	return 0;
+}
+
+int
+main(int argc, char *argv[])
+{
+	struct uboot_image_header hdr;
+	const char *src, *dest;
+	char *ep;
+	int kernel_fd, image_fd;
+	int ch;
+	unsigned long num;
+
+	while ((ch = getopt(argc, argv, "A:C:O:T:a:e:hn:")) != -1) {
+		switch (ch) {
+		case 'A':	/* arch */
+			image_arch = get_arch(optarg);
+			break;
+		case 'C':	/* comp */
+			image_comp = get_comp(optarg);
+			break;
+		case 'O':	/* os */
+			image_os = get_os(optarg);
+			break;
+		case 'T':	/* type */
+			image_type = get_type(optarg);
+			break;
+		case 'a':	/* addr */
+			errno = 0;
+			num = strtoul(optarg, &ep, 0);
+			if (*ep != '\0' || (errno == ERANGE &&
+			    (num == ULONG_MAX || num == 0)))
+				errx(1, "illegal number -- %s", optarg);
+			image_loadaddr = (uint32_t)num;
+			break;
+		case 'e':	/* ep */
+			errno = 0;
+			num = strtoul(optarg, &ep, 0);
+			if (*ep != '\0' || (errno == ERANGE &&
+			    (num == ULONG_MAX || num == 0)))
+				errx(1, "illegal number -- %s", optarg);
+			image_entrypoint = (uint32_t)num;
+			break;
+		case 'n':	/* name */
+			image_name = strdup(optarg);
+			break;
+		case 'h':
+		default:
+			usage();
+			/* NOTREACHED */
+		}
+	}
+	argc -= optind;
+	argv += optind;
+
+	if (argc != 2)
+		usage();
+
+	if (image_entrypoint == 0)
+		image_entrypoint = image_loadaddr;
+
+	if (image_arch == IH_ARCH_UNKNOWN ||
+	    image_type == IH_TYPE_UNKNOWN ||
+	    image_loadaddr == 0 ||
+	    image_name == NULL)
+		usage();
+
+	src = argv[0];
+	dest = argv[1];
+
+	kernel_fd = open(src, O_RDONLY);
+	if (kernel_fd == -1) {
+		perror("open kernel");
+		return EXIT_FAILURE;
+	}
+	image_fd = open(dest, O_WRONLY|O_CREAT, 0666);
+	if (image_fd == -1) {
+		perror("open image");
+		return EXIT_FAILURE;
+	}
+
+	if (generate_header(&hdr, kernel_fd) != 0)
+		return EXIT_FAILURE;
+
+	if (write_image(&hdr, kernel_fd, image_fd) != 0)
+		return EXIT_FAILURE;
+
+	close(image_fd);
+	close(kernel_fd);
+
+	return EXIT_SUCCESS;
+}
